<script setup>
import { ref } from "vue";
import { useStore } from "vuex";
import { useRoute } from "vue-router";

const props = defineProps({
  levelId: { type: String, required: true },
  levelName: { type: String, required: false, default: "" },
  game: { type: String, required: false, default: "" },
});
const emit = defineEmits(["close", "launched"]);
const store = useStore();
const route = useRoute();

const sessionName = ref("");
const sessionArgs = ref(store.getters["level/levelArgs"](props.levelId));

const updateArgs = (key, value) => {
  sessionArgs.value[key]["value"] = value;
};

function launchClicked() {
  store
    .dispatch("live/launchSession", {
      game: props.game || route.params.game,
      level: props.levelId,
      session: sessionName.value,
      args: sessionArgs.value,
    })
    .then((r) => {
      emit("launched", r?.data?.created_id);
    })
    .catch()
    .finally(() => emit("close"));
}
</script>

<template>
  <div>
    <div class="box has-background-pink-2">
      <div class="field">
        <label class="label">Create Session based on {{ levelName || levelId }}</label>
        <div class="control">
          <input v-model="sessionName" class="input" placeholder="Session Name" />
        </div>
      </div>
      <div class="field has-background-light p-3">
        <div v-for="(value, argument) in sessionArgs" :key="'arg' + argument">
          <div class="field">
            <label class="label">{{ argument }} ({{ value.type || value.collection }})</label>
            <div class="control">
              <input
                class="input has-background-dark has-text-light"
                placeholder="database query"
                :value="value.value || value.query"
                @change="updateArgs(argument, $event.target.value)"
              />
            </div>
          </div>
        </div>
      </div>
      <div class="field is-grouped is-grouped-centered">
        <div class="control">
          <button class="button is-dark" @click.stop.prevent="launchClicked">Start Session</button>
        </div>
        <div class="control">
          <button class="button is-dark" @click="emit('close')">Cancel</button>
        </div>
      </div>
    </div>
  </div>
</template>
